unit CapiInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CapiCtrl, StdCtrls, Grids, Spin, ComCtrls, ImgList,  ExtCtrls;

type
  TInfoForm = class(TForm)
    edCapiVersion: TEdit;
    Label1: TLabel;
    edManufVersion: TEdit;
    Label2: TLabel;
    edManuf: TEdit;
    Label3: TLabel;
    edSerialNumber: TEdit;
    Label4: TLabel;
    edIsRegistered: TEdit;
    Label5: TLabel;
    edInstContr: TEdit;
    Label6: TLabel;
    Label8: TLabel;
    TreeView1: TTreeView;
    ImageList1: TImageList;
    Button1: TButton;
    edAppId: TEdit;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    procedure InfoDisplay;
    { Private declarations }
  public
    CapiICtrl:TCapiCtrlPro;
    constructor create(Sender: TComponent; Cc: TCapiCtrlPro); overload;
    { Public declarations }
  end;

var
  InfoForm: TInfoForm;

implementation

{$R *.DFM}

constructor TInfoForm.create(Sender: TComponent; Cc: TCapiCtrlPro);
begin
     CapiICtrl:=Cc;
     inherited Create(Sender);
end;

procedure TInfoForm.FormCreate(Sender: TObject);
begin
     InfoDisplay;
end;

procedure TInfoForm.InfoDisplay;
var
    ControllerNode: TTreeNode;
    GroupNode: TTreeNode;
    DetailNode: TTreeNode;
    i,j :integer;
begin
    with CapiICtrl do
    begin
       edCapiversion.Text := CapiVersion;
       edManufVersion.Text := ManufacturerVersion;
       edManuf.Text := ManufacturerName;
       edSerialNumber.Text := SerialNumber;
       if AppIsRegistered = false then
           edisRegistered.Text := 'false'
       else edIsRegistered.Text := 'true';
       edAppId.Text := inttostr(applicationID);
       edInstContr.Text := inttostr(numcontrollers);

       treeview1.items.Clear;

       for i:= 1 to numcontrollers do begin
           makeControllerProfile(i);
           ControllerNode:=treeview1.Items.AddChild(nil, '');
           ControllerNode.Text := 'Controller ' + inttostr(i);
           ControllerNode.ImageIndex    := 0;
           ControllerNode.SelectedIndex := 0;
           GroupNode:=treeview1.items.AddChild(ControllerNode, '');
           GroupNode.Text := 'General';
           GroupNode.ImageIndex    := 1;
           GroupNode.SelectedIndex := 1;

           j:=1;
           While RecallTCapiPDG(j).desig <>'' do begin
              DetailNode:=treeview1.items.AddChild(GroupNode, '');
              DetailNode.Text :=RecallTCapiPDG(j).desig + ': ' +
                                inttostr(RecallTCapiPDG(j).value);
              DetailNode.ImageIndex    := 4;
              DetailNode.SelectedIndex := 4;
              inc (j);
           end;

           GroupNode:=treeview1.items.AddChild(ControllerNode, '');
           GroupNode.Text := 'Global Options';
           GroupNode.ImageIndex    := 1;
           GroupNode.SelectedIndex := 1;
           j:=1;
           While RecallTCapiPDGO(j).desig <>'' do begin
              DetailNode:=treeview1.items.AddChild(GroupNode, '');
              DetailNode.Text := RecallTCapiPDGO(j).desig + ': ';
              if RecallTCapiPDGO(j).value = false then begin
                 DetailNode.Text :=DetailNode.Text + 'FALSE';
                 DetailNode.ImageIndex    := 2;
                 DetailNode.SelectedIndex := 2;
              end
              else begin
                DetailNode.Text :=DetailNode.Text + 'TRUE';
                DetailNode.ImageIndex    := 3;
                DetailNode.SelectedIndex := 3;
              end;
              inc (j);
           end;

           GroupNode:=treeview1.items.AddChild(ControllerNode, '');
           GroupNode.Text := 'B1 protocol support';
           GroupNode.ImageIndex    := 1;
           GroupNode.SelectedIndex := 1;

           j:=1;
           While RecallTCapiPDB1(j).desig <>'' do begin
              DetailNode:=treeview1.items.AddChild(GroupNode, '');
              DetailNode.Text := RecallTCapiPDB1(j).desig + ': ';
              if RecallTCapiPDB1(j).value = false then begin
                 DetailNode.Text :=DetailNode.Text + 'FALSE';
                 DetailNode.ImageIndex    := 2;
                 DetailNode.SelectedIndex := 2;
              end
              else begin
                DetailNode.Text :=DetailNode.Text + 'TRUE';
                DetailNode.ImageIndex    := 3;
                DetailNode.SelectedIndex := 3;
              end;
              inc(j);
           end;

           GroupNode:=treeview1.items.AddChild(ControllerNode, '');
           GroupNode.Text := 'B2 protocol support';
           GroupNode.ImageIndex    := 1;
           GroupNode.SelectedIndex := 1;
           j:=1;
           While RecallTCapiPDB2(j).desig <> '' do begin
              DetailNode:=treeview1.items.AddChild(GroupNode, '');
              DetailNode.Text := RecallTCapiPDB2(j).desig + ': ';
              if RecallTCapiPDB2(j).value = false then begin
                 DetailNode.Text :=DetailNode.Text + 'FALSE';
                 DetailNode.ImageIndex    := 2;
                 DetailNode.SelectedIndex := 2;
              end
              else begin
                DetailNode.Text :=DetailNode.Text + 'TRUE';
                DetailNode.ImageIndex    := 3;
                DetailNode.SelectedIndex := 3;
              end;
              inc(j);
           end;

           GroupNode:=treeview1.items.AddChild(ControllerNode, '');
           GroupNode.Text := 'B3 protocol support';
           GroupNode.ImageIndex    := 1;
           GroupNode.SelectedIndex := 1;
           j:=1;
           While RecallTCapiPDB3(j).desig <> '' do begin
              DetailNode:=treeview1.items.AddChild(GroupNode, '');
              DetailNode.Text := RecallTCapiPDB3(j).desig + ': ';
              if RecallTCapiPDB3(j).value = false then begin
                 DetailNode.Text :=DetailNode.Text + 'FALSE';
                 DetailNode.ImageIndex    := 2;
                 DetailNode.SelectedIndex := 2;
              end
              else begin
                DetailNode.Text :=DetailNode.Text + 'TRUE';
                DetailNode.ImageIndex    := 3;
                DetailNode.SelectedIndex := 3;
              end;
              ControllerNode.Expand (false);
              inc(j);
           end;
      end;
    end;
end;

end.
